<?php

ini_set('soap.wsdl_cache_enabled',0);
ini_set('soap.wsdl_cache_ttl',0);

class WebServiceExemplo{

    public function cancelarNfse($soapClient){
        $id_pedido_cancelamento = "pedidoCancelamento_999999990001911733160024200900000000001";
        $numero = "201800000000002";
        $cnpj_prestador = "99999999999999";
        $inscricao_municipal = "279";
        $codigo_municipio = "4205506";
        $codigo_cancelamento = "2";

        $xml = '
            <CancelarNfseEnvio xmlns="http://www.abrasf.org.br/nfse.xsd">
                <Pedido xmlns="http://www.abrasf.org.br/nfse.xsd">
                    <InfPedidoCancelamento
                        Id="'.$id_pedido_cancelamento.'">
                        <IdentificacaoNfse>
                            <Numero>'.$numero.'</Numero>
                            <Cnpj>'.$cnpj_prestador.'</Cnpj>
                            <InscricaoMunicipal>'.$inscricao_municipal.'</InscricaoMunicipal>
                            <CodigoMunicipio>'.$codigo_municipio.'</CodigoMunicipio>
                        </IdentificacaoNfse>
                        <CodigoCancelamento>'.$codigo_cancelamento.'</CodigoCancelamento>
                    </InfPedidoCancelamento>
                </Pedido>
            </CancelarNfseEnvio>    
            ';
            
        $entrada = [
                'nfseCabecMsg' => '<versaoDados>1.00</versaoDados>',
                'nfseDadosMsg' => $xml,
        ];

        return $soapClient->cancelarNfse($entrada);
    }
    
    public function consultarLoteRps($soapClient){
        $cnpj_prestador = "99999999999999";
        $inscricao_municipal = "279";
        $protocolo = "ed3c766f3154d52a06fc52698dbd892fa425790f";

        $xml = "<ConsultarLoteRpsEnvio xmlns='http://www.abrasf.org.br/nfse.xsd'>
                    <Prestador>
                        <Cnpj>{$cnpj_prestador}</Cnpj>
                        <InscricaoMunicipal>{$inscricao_municipal}</InscricaoMunicipal>
                    </Prestador>
                    <Protocolo>{$protocolo}</Protocolo>
                </ConsultarLoteRpsEnvio>";

        $entrada = [
            'nfseCabecMsg' => '<versaoDados>1.00</versaoDados>',
            'nfseDadosMsg' => $xml,
        ];

        return $soapClient->consultarLoteRps($entrada);
    }
    
    public function recepcionarLoteRps($soapClient){       

        $numero_lote = (int)(new DateTime())->format('YmdHis');
        $cnpj_prestador = "99999999999999";
        $inscricao_municipal = "279";
		$qnte_rps = 2;
		$lista_rps = "";
	
		$i=1;
		while($i <= $qnte_rps){
            $numero_rps = (int)(new DateTime())->format('mdHis').$i;
			$lista_rps .= "<Rps>".
					"<InfRps Id=\"rps_1ABCDZ\">".
					"<IdentificacaoRps>".
					"<Numero>".$numero_rps."</Numero>".
					"<Serie>ABCDZ</Serie>".
					"<Tipo>1</Tipo>".
					"</IdentificacaoRps>".
					"<DataEmissao>2009-06-16T21:00:00</DataEmissao>".
					"<NaturezaOperacao>1</NaturezaOperacao>".
					"<RegimeEspecialTributacao>6</RegimeEspecialTributacao>".
					"<OptanteSimplesNacional>1</OptanteSimplesNacional>".
					"<IncentivadorCultural>2</IncentivadorCultural>".
					"<Status>1</Status>".
					"<Servico>".
					"<Valores>".
					"<ValorServicos>1000.00</ValorServicos>".
					"<ValorDeducoes>10.00</ValorDeducoes>".
					"<ValorPis>10.00</ValorPis>".
					"<ValorCofins>10.00</ValorCofins>".
					"<ValorInss>10.00</ValorInss>".
					"<ValorIr>10.00</ValorIr>".
					"<ValorCsll>10.00</ValorCsll>".
					"<IssRetido>1</IssRetido>".
					"<ValorIss>10.00</ValorIss>".
					"<OutrasRetencoes>10.00</OutrasRetencoes>".
					"<Aliquota>5</Aliquota>".
					"<DescontoIncondicionado>10.00</DescontoIncondicionado>".
					"<DescontoCondicionado>10.00</DescontoCondicionado>".
					"</Valores>".
					"<ItemListaServico>11.01</ItemListaServico>".
					"<CodigoTributacaoMunicipio>522310000</CodigoTributacaoMunicipio>".
					"<Discriminacao>Teste. a fasd fasd fasd fas</Discriminacao>".
					"<CodigoMunicipio>3106200</CodigoMunicipio>".
					"</Servico>".
					"<Prestador>".
					"<Cnpj>{$cnpj_prestador}</Cnpj>".
					"<InscricaoMunicipal>{$inscricao_municipal}</InscricaoMunicipal>".
					"</Prestador>".
					"<Tomador>".
					"<IdentificacaoTomador>".
					"<CpfCnpj>".
					"<Cnpj>08002473000130</Cnpj>".
					"</CpfCnpj>".
					"<InscricaoMunicipal>1733160032</InscricaoMunicipal>".
					"</IdentificacaoTomador>".
					"<RazaoSocial>INSCRICAO DE TESTE SIATU - D'AGUA -PAULINO'S</RazaoSocial>".
					"<Endereco>".
					"<Endereco>DA BAHIA</Endereco>".
					"<Numero>200</Numero>".
					"<Complemento>ANDAR 14</Complemento>".
					"<Bairro>CENTRO</Bairro>".
					"<CodigoMunicipio>3106200</CodigoMunicipio>".
					"<Uf>MG</Uf>".
					"<Cep>30160010</Cep>".
					"</Endereco>".
					"</Tomador>".
					"<IntermediarioServico>".
					"<RazaoSocial>INSCRICAO DE TESTE SIATU - D'AGUA -PAULINO'S</RazaoSocial>".
					"<CpfCnpj>".
					"<Cnpj>99999999000191</Cnpj>".
					"</CpfCnpj>".
					"<InscricaoMunicipal>8041700010</InscricaoMunicipal>".
					"</IntermediarioServico>".
					"<ConstrucaoCivil>".
					"<CodigoObra>1234</CodigoObra>".
					"<Art>1234</Art>".
					"</ConstrucaoCivil>".
					"</InfRps>".
					"</Rps>";
			$i++;
		}

        $xml = '
            <EnviarLoteRpsEnvio xmlns="http://www.abrasf.org.br/nfse.xsd">
                <LoteRps Id="lote" versao="1.00">
                    <NumeroLote>'.$numero_lote.'</NumeroLote>
                    <Cnpj>'.$cnpj_prestador.'</Cnpj>
                    <InscricaoMunicipal>'.$inscricao_municipal.'</InscricaoMunicipal>
                    <QuantidadeRps>'.$qnte_rps.'</QuantidadeRps>
                    <ListaRps>'.$lista_rps.'</ListaRps>
                </LoteRps>
            </EnviarLoteRpsEnvio> 
            ';
            
        $entrada = [
                'nfseCabecMsg' => '<versaoDados>1.00</versaoDados>',
                'nfseDadosMsg' => $xml,
        ];

        return $soapClient->recepcionarLoteRps($entrada);
    }

    public function consultarNfse($soapClient){
        $xml = '<?xml version="1.0" encoding="UTF-8"?>
            <ConsultarNfseEnvio xmlns="http://www.abrasf.org.br/nfse.xsd">
                <Prestador>
                    <Cnpj>99999999999999</Cnpj>
                    <InscricaoMunicipal>279</InscricaoMunicipal>
                </Prestador>
                <PeriodoEmissao>
                    <DataInicial>2018-03-01</DataInicial>
                    <DataFinal>2018-03-20</DataFinal>
                </PeriodoEmissao>
            </ConsultarNfseEnvio>';
            
        $entrada = [
                'nfseCabecMsg' => '<versaoDados>1.00</versaoDados>',
                'nfseDadosMsg' => $xml,
        ];

        return $soapClient->consultarNfse($entrada);
    }

    public function consultarSituacaoLoteRps($soapClient){
        $cnpj_prestador = "99999999999999";
        $inscricao_municipal = "279";
        $protocolo = "ed3c766f3154d52a06fc52698dbd892fa425790f";

        $xml = "<ConsultarSituacaoLoteRpsEnvio xmlns='http://www.abrasf.org.br/nfse.xsd'>
                    <Prestador>
                        <Cnpj>{$cnpj_prestador}</Cnpj>
                        <InscricaoMunicipal>{$inscricao_municipal}</InscricaoMunicipal>
                    </Prestador>
                    <Protocolo>{$protocolo}</Protocolo>
                 </ConsultarSituacaoLoteRpsEnvio>";

        $entrada = [
            'nfseCabecMsg' => '<versaoDados>1.00</versaoDados>',
            'nfseDadosMsg' => $xml,
        ];

        return $soapClient->consultarSituacaoLoteRps($entrada);
    }

    public function consultarNfseRps($soapClient){
        $numero_rps = "3221615392";
        $serie_rps = "ABCDZ";
        $tipo_rps = "1";
        $cnpj_prestador = "99999999999999";
        $inscricao_municipal = "279";

        $xml = "<ConsultarNfseRpsEnvio xmlns='http://www.abrasf.org.br/nfse.xsd'>
                    <IdentificacaoRps>
                        <Numero>{$numero_rps}</Numero>
                        <Serie>{$serie_rps}</Serie>
                        <Tipo>{$tipo_rps}</Tipo>
                    </IdentificacaoRps>
                    <Prestador>
                        <Cnpj>{$cnpj_prestador}</Cnpj>
                        <InscricaoMunicipal>{$inscricao_municipal}</InscricaoMunicipal>
                    </Prestador>
                </ConsultarNfseRpsEnvio>";

        $entrada = [
            'nfseCabecMsg' => '<versaoDados>1.00</versaoDados>',
            'nfseDadosMsg' => $xml,
        ];

        return $soapClient->consultarNfseRps($entrada);
    }

    public function iniciar(){
        
        // ambiente de testes
        $wsdl = "https://nfse-testes.ciga.sc.gov.br/webservice/v1?wsdl";
        
        // ambiente em produção
        // $wsdl = "https://nfse.ciga.sc.gov.br/webservice/v1?wsdl";
        

        // certificado digital A1 do prestador do serviço
        $cert_path = '/path/to/certificado_prestador.pem';
        // formato do arquivo .pem
        // -----BEGIN ENCRYPTED PRIVATE KEY----- 
        // (Your Private Key: your_domain_name.key) 
        // -----END ENCRYPTED PRIVATE KEY----- 
        // -----BEGIN CERTIFICATE----- 
        // (Your Primary SSL certificate) 
        // -----END CERTIFICATE----- 
        // -----BEGIN CERTIFICATE----- 
        // (CA certificate) 
        // -----END CERTIFICATE----- 
        

        $opt = ['stream_context' =>
                stream_context_create([
                    'ssl' => [
                        'peer_name' => "*.ciga.sc.gov.br",
                        'local_cert' => $cert_path,
                        'passphrase' => "passphrase"
                    ]])
        ];

        $soapClient = new SoapClient($wsdl, $opt);

        echo "Todos os métodos disponíveis do webservice:";
        var_dump($soapClient->__getFunctions());


        //chama método do webservice
        // $resul = $this->cancelarNfse($soapClient);
        // $resul = $this->consultarLoteRps($soapClient);
        // $resul = $this->recepcionarLoteRps($soapClient);
        // $resul = $this->consultarNfse($soapClient);
        // $resul = $this->consultarSituacaoLoteRps($soapClient);
        $resul = $this->consultarNfseRps($soapClient);

        echo "Resposta: ";
        echo $resul->outputXML;

        // visualiza xml de resposta
        // $doc = new DomDocument('1.0');
        // $doc->preserveWhiteSpace = false;
        // $doc->formatOutput = true;
        // $doc->loadXML($resul->outputXML);
        // echo '<pre>', htmlentities($doc->saveXML()), '</pre>'; 
    }
}

?>